/*
 *
 * $Id$
 */

#include "kt_lib.h"

/* callback of type Kt_ServerMsgCallback */
static void
cb(Kt_Context context, void *userData, Kt_Message msg, CARD32 krlId)
{
   CARD32 priority = (CARD32) userData;
   printf("Handling with handler of priority %d\n", priority);

   kt_MessageReply(context, msg, kt_MessageNew());

}

void
main(int argc, char **argv)
{
   Kt_Context context;
   Kt_Message msg;
   Bool isDispatched;
   char *coord, **servers, *krs;
   int n;
   char *arg1;
   CARD32 priority;

   if (argc != 2 && argc != 3) {
      printf("usage: mhandle <priority> [regexp]\n");
      exit(0);
   }
   else
      priority = atoi(argv[1]);

   if (3 == argc)
      krs = argv[2];
   else
      krs = "koala.*";

   printf("Handling '%s' with priority %d\n", krs, priority);

   kt_LocateServer(& servers, & n);
   if (n > 0) {
      context = kt_Init(0, 0, 0, 0);
      kt_OpenServerConnection(context, servers[0], "Priority test");
      kt_KRHandleWithPriority(context, krs, priority, cb, (void*)priority);

      while (1) {
	 kt_NextMessage(context, & msg);
	 isDispatched = kt_DispatchMessage(context, msg);
      }
   }
   else {
      printf("no server\n");
   }
}

